/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Get PO data
*/

CREATE PROCEDURE [dbo].[SP_DLV_VIEW_PO]
@vPO_MONTH VARCHAR (MAX),
@vPO_NO	VARCHAR (MAX),
@vLOG_PARTNER_NAME	VARCHAR (MAX),
@vPR_NO	VARCHAR (MAX),
@vSTATUS	VARCHAR (MAX)

AS
BEGIN
	DECLARE @QUERY VARCHAR (MAX);
	CREATE TABLE #TEMP_VIEW_PO(
	PO_NUMBER VARCHAR(12),PRODUCTION_MONTH VARCHAR (12),CODE VARCHAR(10),LOG_PARTNER_NAME VARCHAR(MAX),
	TOTAL_ROUTE VARCHAR(MAX),REMAINING_ROUTE VARCHAR(MAX),PR_NUMBER VARCHAR(12), PR_STATUS_FLAG VARCHAR(10),
	STATUS VARCHAR(MAX),CREATE_BY VARCHAR(50), CREATE_DT DATETIME,CHANGE_BY VARCHAR(50), CHANGE_DT DATETIME, STATUS_PO VARCHAR(MAX)
	);
	
	INSERT INTO #TEMP_VIEW_PO (PO_NUMBER,PRODUCTION_MONTH,CODE,LOG_PARTNER_NAME,TOTAL_ROUTE,REMAINING_ROUTE,
	PR_NUMBER,PR_STATUS_FLAG,STATUS,CREATE_BY,CREATE_DT,CHANGE_BY,CHANGE_DT,STATUS_PO)
	
	SELECT POH.PO_NO AS PO_NUMBER,
		   PRH.PROD_MONTH AS PRODUCTION_MONTH,
		   PRH.LP_CD AS CODE,
		   PARTNER.LOG_PARTNER_NAME,
		   (SELECT COUNT(POD.PO_QTY) FROM TB_R_DLV_PO_ITEM POD WHERE POD.PO_NO = POH.PO_NO) as TOTAL_ROUTE,
		   (SELECT COUNT(PRD.PR_QTY) FROM TB_R_DLV_PR_D PRD WHERE PRD.PR_NO = PRH.PR_NO) - (SELECT COUNT(POD.PO_QTY) FROM TB_R_DLV_PO_ITEM POD WHERE POD.PO_NO = POH.PO_NO) as REMAINING_ROUTE,
			 PRH.PR_NO AS PR_NUMBER,PRH.PR_STATUS_FLAG,
			 (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = ISNULL(POH.PO_STATUS_FLAG,PRH.PR_STATUS_FLAG)) AS STATUS,
			  POH.CREATED_BY AS CREATE_BY,
			  POH.CREATED_DT AS CREATE_DT,
			  POH.CHANGED_BY AS CHANGE_BY,
			  POH.CHANGED_DT AS CHANGE_DT,
			  (CASE
				WHEN POH.PO_STATUS_FLAG ='PO1' THEN 'B'
				WHEN POH.PO_STATUS_FLAG ='PO2' THEN 'C'
				WHEN POH.PO_STATUS_FLAG ='PO3' THEN 'D'
				WHEN POH.PO_STATUS_FLAG ='PO4' THEN 'E'
				WHEN POH.PO_STATUS_FLAG ='PO5' THEN 'F'
				WHEN POH.PO_STATUS_FLAG ='PO6' THEN 'G' 
				ELSE 'A'
			  END) AS STATUS_PO 	 
	FROM TB_R_DLV_PR_H PRH
	LEFT JOIN
	TB_R_DLV_PO_H POH ON POH.PROD_MONTH = PRH.PROD_MONTH AND POH.LP_CD = PRH.LP_CD AND POH.PO_STATUS_FLAG <> 'PO5'
	LEFT JOIN TB_M_LOGISTIC_PARTNER PARTNER ON PARTNER.LOG_PARTNER_CD = PRH.LP_CD
	LEFT JOIN TB_M_SYSTEM SYSTEM ON SYSTEM.SYSTEM_CD = POH.PO_STATUS_FLAG 
	WHERE PRH.PR_STATUS_FLAG ='PR5'
	UNION ALL
	SELECT POH.PO_NO AS PO_NUMBER,
		   PRH.PROD_MONTH AS PRODUCTION_MONTH,
		   PRH.LP_CD AS CODE,
		   PARTNER.LOG_PARTNER_NAME,
		   (SELECT COUNT(POD.PO_QTY) FROM TB_R_DLV_PO_ITEM POD WHERE POD.PO_NO = POH.PO_NO) as TOTAL_ROUTE,
			(SELECT COUNT(PRD.PR_QTY) FROM TB_R_DLV_PR_D PRD WHERE PRD.PR_NO = PRH.PR_NO) - (SELECT COUNT(POD.PO_QTY) FROM TB_R_DLV_PO_ITEM POD WHERE POD.PO_NO = POH.PO_NO) as REMAINING_ROUTE,
			 PRH.PR_NO AS PR_NUMBER,POH.PO_STATUS_FLAG,
			 (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = ISNULL(POH.PO_STATUS_FLAG,PRH.PR_STATUS_FLAG)) AS STATUS,
			  POH.CREATED_BY AS CREATE_BY,
			  POH.CREATED_DT AS CREATE_DT,
			  POH.CHANGED_BY AS CHANGE_BY,
			  POH.CHANGED_DT AS CHANGE_DT,
			  (CASE
				WHEN POH.PO_STATUS_FLAG ='PO1' THEN 'B' 
				WHEN POH.PO_STATUS_FLAG ='PO2' THEN 'C'
				WHEN POH.PO_STATUS_FLAG ='PO3' THEN 'D'
				WHEN POH.PO_STATUS_FLAG ='PO4' THEN 'E'
				WHEN POH.PO_STATUS_FLAG ='PO5' THEN 'F'
				WHEN POH.PO_STATUS_FLAG ='PO6' THEN 'G' 
				ELSE 'A'
			   END) AS STATUS_PO 	 	 
	FROM TB_R_DLV_PR_H PRH
	LEFT JOIN
	TB_R_DLV_PO_H POH ON POH.PROD_MONTH = PRH.PROD_MONTH AND POH.LP_CD = PRH.LP_CD
	LEFT JOIN TB_M_LOGISTIC_PARTNER PARTNER ON PARTNER.LOG_PARTNER_CD = PRH.LP_CD
	--LEFT JOIN TB_M_SYSTEM SYSTEM ON SYSTEM.SYSTEM_CD = POH.PO_STATUS_FLAG 
	WHERE PRH.PR_STATUS_FLAG ='PR5' AND POH.PO_STATUS_FLAG = 'PO5';
	
	

SET @QUERY =' SELECT * FROM #TEMP_VIEW_PO WHERE 1=1';


IF @vPO_MONTH != '' SET @QUERY = @QUERY + ' AND PRODUCTION_MONTH IN (''' + @vPO_MONTH + ''')' 
IF @vPO_NO != '' SET @QUERY = @QUERY + ' AND PO_NUMBER LIKE ''%' + @vPO_NO + '%'''
IF @vPR_NO != '' SET @QUERY = @QUERY + ' AND PR_NUMBER LIKE ''%' + @vPR_NO + '%'''
IF @vLOG_PARTNER_NAME != '' SET @QUERY = @QUERY + ' AND CODE IN ('+ cast (@vLOG_PARTNER_NAME as varchar (max)) +')'
IF @vSTATUS != '' SET @QUERY = @QUERY + ' AND STATUS IN ('+ cast (@vSTATUS as varchar (max)) +')'

SET @QUERY = @QUERY + ' ORDER BY STATUS_PO ASC' 
IF (@vPO_MONTH <> '') OR (@vPR_NO <> '') OR (@vPO_NO <> '') OR (@vLOG_PARTNER_NAME <> '') OR (@vSTATUS <> '')

EXECUTE (@QUERY)

END

